#--Peer evaluation--

rm(list=ls(all=TRUE))
#--change working directory below--
setwd("d:/class/662/")
options(echo=TRUE)
library(foreign)

#--Need to have this csv file in your working directory--
#--Column is evaluator, row is the evaluated (1 highest, 15 lowest)--
bb<-read.csv("evalData.csv")
head(bb)
names<-bb[,1]
#--remove first column of names, reverse order (15 highest, 1 lowest)--
bb<-(NROW(bb)+1)-as.matrix(bb[,c(-1)])
#--set diagonal equal zero--
colSums(bb)
diag(bb)<-0

#--recalculate column ranks--
vv<-matrix(0,NROW(bb),NROW(bb))
for (i in 1:NCOL(bb)){
vv[,i]<-rank(bb[,i],ties.method="average")
}
#--check to see column sums are same for all columns--
colSums(vv)

#--calculate eigenvectors--
v<-eigen(vv*t(vv))
#--make sure that all values of 1st eigenvector same sign--
cbind(min(v$vectors[,1]),max(v$vectors[,1]))
#--create output, display it sorted, then save (unsorted) in csv file--
u<-cbind(names,data.frame(abs(v$vectors[,1])))
names(u)[2]<-"absEV"
mingrade<-60
u$grade<-mingrade+(100-mingrade)*u$absEV/max(u$absEV)
u[order(-u[,2]),]
#--writes evaluation to csv file--
write.csv(u,file="eval.csv")

